name: Build and Publish Docker Images

on:
  workflow_dispatch:
  push:
    branches: 
     - '**'
    tags:
      - 'v*.*.*'
  pull_request:

jobs:
   build_and_publish:
    runs-on: ubuntu-latest
    name: Build and Publish Docker images
    steps:
      - name: Checkout
        uses: actions/checkout@v3
        with:
          fetch-depth: 2
      - name: Docker meta
        id: docker_meta
        uses: crazy-max/ghaction-docker-meta@v1
        with:
          images: ghcr.io/${{ github.repository_owner }}/willow-playground
      - name: Set up Docker Buildx
        uses: docker/setup-buildx-action@v1
      - name: Login to Container Registry
        if: github.event_name != 'pull_request'
        uses: docker/login-action@v1
        with:
          registry: ghcr.io
          username: ${{ secrets.DOCKER_REGISTRY_USERNAME }}
          password: ${{ secrets.DOCKER_REGISTRY_TOKEN }}
      - name: Docker build and push
        uses: docker/build-push-action@v2
        with:
          context: ./
          file: ./docker/Dockerfile
          push: ${{ github.event_name != 'pull_request' }}
          tags: ${{ steps.docker_meta.outputs.tags }}
          labels: ${{ steps.docker_meta.outputs.labels }}
          secrets: GIT_AUTH_TOKEN=${{ secrets.DOCKER_REGISTRY_TOKEN }}
